/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.financial.erpcredit.service;

import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.financial.erpcredit.entity.*;
import com.jeeplus.modules.sg.financial.erpcredit.mapper.ErpCreditChild1Mapper;
import com.jeeplus.modules.sg.financial.erpcredit.mapper.ErpCreditChild2Mapper;
import com.jeeplus.modules.sg.financial.erpcredit.mapper.ErpCreditChild3Mapper;
import com.jeeplus.modules.sg.financial.erpcredit.mapper.ErpCreditMapper;
import com.jeeplus.modules.sg.financial.erpcredit.util.ErpInfo;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild11;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild12;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild13;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataMain1;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
@Transactional(readOnly = true)
public class ErpCreditService extends CrudService<ErpCreditMapper,ErpCredit> {
    @Autowired
    private ErpCreditChild1Mapper erpCreditChild1Mapper;
    @Autowired
    private ErpCreditChild2Mapper erpCreditChild2Mapper;
    @Autowired
    private ErpCreditChild3Mapper erpCreditChild3Mapper;

    public ErpCredit get(String id) {
        ErpCredit erpCredit = super.get(id);
        erpCredit.setErpCreditChild1s(erpCreditChild1Mapper.findList(new ErpCreditChild1(erpCredit)));
        erpCredit.setErpCreditChild2s(erpCreditChild2Mapper.findList(new ErpCreditChild2(erpCredit)));
        erpCredit.setErpCreditChild3s(erpCreditChild3Mapper.findList(new ErpCreditChild3(erpCredit)));
        return erpCredit;
    }

    public List<ErpCredit> findList(ErpCredit erpCredit) {
        return super.findList(erpCredit);
    }

    public Page<ErpCredit> findPage(Page<ErpCredit> page, ErpCredit erpCredit) {
        return super.findPage(page, erpCredit);
    }

    @Transactional(readOnly = false)
    public void save(ErpCredit erpCredit) {
        System.out.println(erpCredit);
        super.save(erpCredit);
        for (ErpCreditChild1 erpCreditChild1 : erpCredit.getErpCreditChild1s()){
            if (erpCreditChild1.getErpCredit().getItemId().isEmpty()){
                continue;
            }
            if (ErpCreditChild1.DEL_FLAG_NORMAL.equals(erpCredit.getDelFlag())){
                erpCreditChild1.setErpCredit(erpCredit);
                erpCreditChild1.preInsert();
                erpCreditChild1Mapper.insert(erpCreditChild1);
            }
        }
        for (ErpCreditChild2 erpCreditChild2 : erpCredit.getErpCreditChild2s()){
            if (erpCreditChild2.getErpCredit().getItemId().isEmpty()){
                continue;
            }
            if (ErpCreditChild2.DEL_FLAG_NORMAL.equals(erpCreditChild2.getDelFlag())){
                erpCreditChild2.setErpCredit(erpCredit);
                erpCreditChild2.preInsert();
                erpCreditChild2Mapper.insert(erpCreditChild2);
            }
        }
        for (ErpCreditChild3 erpCreditChild3 : erpCredit.getErpCreditChild3s()){
            if (erpCreditChild3.getErpCredit().getItemId().isEmpty()){
                continue;
            }
            if (ErpCreditChild3.DEL_FLAG_NORMAL.equals(erpCreditChild3.getDelFlag())){
                erpCreditChild3.setErpCredit(erpCredit);
                erpCreditChild3.preInsert();
                erpCreditChild3Mapper.insert(erpCreditChild3);
            }
        }
    }

    @Transactional(readOnly = false)
    public void delete(ErpCredit erpCredit) {
        super.delete(erpCredit);
        erpCreditChild1Mapper.delete(new ErpCreditChild1(erpCredit));
        erpCreditChild2Mapper.delete(new ErpCreditChild2(erpCredit));
        erpCreditChild3Mapper.delete(new ErpCreditChild3(erpCredit));
    }
}